package lilivel.b4a.miscUtil;

import java.util.ArrayList;

import android.content.ContentProviderOperation;
import android.content.ContentResolver;
import android.provider.ContactsContract;
import android.util.Log;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

@ShortName("miscUtil") // this is the name as it appear on the IDE
@Permissions(values = {"android.permission.GET_ACCOUNTS", "android.permission.READ_CONTACTS", "android.permission.WRITE_CONTACTS"}) 
@Author("Michael Peter") // your name
@Version(1f) // the version
@ActivityObject
public class miscUtil {

    public static final String TAG = "lilivel.b4a.miscUtil";   
    private BA m_ba;
    
	/**
	* Common initialisations
	*/	
    public void Initialize(BA ba) {
      m_ba = ba;
    }

	/**
	* Creates the contact entry
	*/
	public void createContactEntry(String name, String phone, int phoneType, String email, int emailType) {
		// Prepare contact creation request
		//
		// Note: We use RawContacts because this data must be associated with a particular account.
		// The system will aggregate this with any other data for this contact and create a
		// coresponding entry in the ContactsContract.Contacts provider for us.
		ArrayList<ContentProviderOperation> ops = new ArrayList<ContentProviderOperation>();
		ops.add(ContentProviderOperation.newInsert(ContactsContract.RawContacts.CONTENT_URI)
		.withValue(ContactsContract.RawContacts.ACCOUNT_TYPE, null)   //Account.getType() ?
		.withValue(ContactsContract.RawContacts.ACCOUNT_NAME, null)   //Account.getName() ?
		.build());
		ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
		.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
		.withValue(ContactsContract.Data.MIMETYPE,
		ContactsContract.CommonDataKinds.StructuredName.CONTENT_ITEM_TYPE)
		.withValue(ContactsContract.CommonDataKinds.StructuredName.DISPLAY_NAME, name)
		.build());
		ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
		.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
		.withValue(ContactsContract.Data.MIMETYPE,
		ContactsContract.CommonDataKinds.Phone.CONTENT_ITEM_TYPE)
		.withValue(ContactsContract.CommonDataKinds.Phone.NUMBER, phone)
		.withValue(ContactsContract.CommonDataKinds.Phone.TYPE, phoneType)
		.build());
		ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
		.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
		.withValue(ContactsContract.Data.MIMETYPE,
		ContactsContract.CommonDataKinds.Email.CONTENT_ITEM_TYPE)
		.withValue(ContactsContract.CommonDataKinds.Email.DATA, email)
		.withValue(ContactsContract.CommonDataKinds.Email.TYPE, emailType)
		.build());

		// Ask the Contact provider to create a new contact
		Log.i(TAG,"Creating contact: " + name);
		try {
			ContentResolver cr = m_ba.context.getContentResolver();
			cr.applyBatch(ContactsContract.AUTHORITY, ops);
		} catch (Exception e) {
			// Log exception
			Log.e(TAG, "Exceptoin encoutered while inserting contact: " + e);
		}	

	}
}
